
var eds = eds || {};
(function() {
	var validateDelimiter = function(delimiter) {
		//delimiter = String(delimiter || '/').charAt(0);
		if (delimiter == '[' || delimiter == ']' || delimiter <= ' ') {
			throw new Error('Illegal delimiter: "' + delimiter + '"');
		}
		return delimiter;
	};
	eds.stringify = function(value, levelDelimiter) {
		levelDelimiter = validateDelimiter(levelDelimiter);
		var walk = function(result, value, upperLevel) {
			var section = [];
			for (var p in value) {
				if (!value.hasOwnProperty(p)) {
					continue;
				}
				var v = value[p];
				var t = Object.prototype.toString.call(v);
				if (t == '[object Object]') {
					section.push('\n\n[' + upperLevel + p + ']\n');
					walk(section, v, upperLevel + p + levelDelimiter);
					continue;
				}
				v = [].concat(v);
				for (var i = 0; i < v.length; i++) {
					result.push(p + '=' + v[i]);
				}
			}
			result.push.apply(result, section);
		};
		var result = [];
		walk(result, value, '');
		return result.join('\n');
	};
	eds.parse = function(text, levelDelimiter, deepen) {
		levelDelimiter = validateDelimiter(levelDelimiter);
		var result = {};
		var ptr = result;
		var setPtr = (function() {
			if (!deepen) {
				return function(section) {
					if (!result.hasOwnProperty(section)) {
						result[section] = {};
					}
					ptr = result[section];
				}
			}
			return function(section) {
				var t = section.split(levelDelimiter)
				ptr = result
				let index = ''

				for (var i = 0; i < t.length; i++) {
					
					var u = t[i];
					if (!u) {
						continue;
					}
					
					if (i == 0) {
						if (!ptr.hasOwnProperty(u)) {
							ptr[u] = {};
						}
						ptr = ptr[u]
						index = u
					}
					else {
						if (!ptr.hasOwnProperty('subs')) {
							ptr.subs = {};
						}
						if (!ptr.subs.hasOwnProperty(u)) {
							ptr.subs[u] = {};
						}
						ptr = ptr.subs[u]
						index += `:${u}`
					}
					//console.log(ptr)
					ptr.index = index
				}
			}
		})();
		var nextLine = (function() {
			if (typeof text == 'function') {
				return text;
			}
			if (Object.prototype.toString.call(text) == '[object Array]') {
				var n = text.length;
				var i = 0;
				return function() {
					return n-- ? text[i++] : null;
				};
			}
			var re = /[^\r\n]+/g;
			return function() {
				var r = re.exec(text);
				return r && r[0];
			}
		})();
		var reSec = /^\s*\[([^\[\]]+)\]\s*$/;
		var reKey = /^\s*([^;#\s][^=]*?)\s*=([^\r\n]*?)$/;
		var line, m, k, v;
		while ((line = nextLine()) != null) {
			m = line.match(reSec);
			if (m) {
				setPtr(m[1]);
				continue;
			}
			m = line.match(reKey);
			if (m) {
				k = m[1];
				v = m[2];
				if (!ptr.hasOwnProperty(k)) {
					ptr[k] = v;
				} else {
					if (typeof ptr[k] == 'string') {
						ptr[k] = [ptr[k]];
					}
					ptr[k].push(v);
				}
				continue;
			}
		}
		return result;
	};
})();